<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.12">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../favicon.png">
  <title>Data types | Chi documentation</title>
  <link rel="stylesheet" href="../assets/asciidoctor-escet-chi.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../assets/styles/asciidoctor-highlightjs-escet.min.css"> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../assets/asciidoctor-escet-chi.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="..">Chi website</a></p>
    <div id="toctitle">
     Chi documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation.html">Home</a></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="index.html">Chi Tutorial</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="introduction.html">Introduction</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="introduction.html#chi-in-a-nutshell">Chi in a nutshell</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="introduction.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-cur-page toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Data types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#booleans">Booleans</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#enumerations">Enumerations</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#numbers">Numbers</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#strings">Strings</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#tuple-types">Tuple types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#notation">Notation</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#operator">Operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#lists">Lists</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#initialization">Initialization</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#sets">Sets</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#dictionaries">Dictionaries</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#custom-types">Custom types</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#the-assignment-statement">The assignment statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#the-if-statement">The <code>if</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#the-while-statement">The <code>while</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#the-for-statement">The <code>for</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="functions.html">Functions</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="functions.html#sorted-lists">Sorted lists</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="functions.html#sort">Sort</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="functions.html#insert">Insert</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="input-output.html">Input and output</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#the-read-function">The <code>read</code> function</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#reading-from-a-file">Reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#advanced-reading-from-a-file">Advanced reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#the-write-statement">The <code>write</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="input-output.html#writing-to-a-file">Writing to a file</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="stochastic-behavior.html">Modeling stochastic behavior</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="stochastic-behavior.html#distributions">Distributions</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="stochastic-behavior.html#constant-distributions">Constant distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="stochastic-behavior.html#discrete-distributions">Discrete distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="stochastic-behavior.html#continuous-distributions">Continuous distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="stochastic-behavior.html#references">References</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stochastic-behavior.html#simulating-stochastic-behavior">Simulating stochastic behavior</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="stochastic-behavior.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="processes.html">Processes</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="processes.html#a-single-process">A single process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="processes.html#a-process-in-a-process">A process in a process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="processes.html#many-processes">Many processes</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="channels.html">Channels</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="channels.html#a-channel">A channel</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="channels.html#synchronization-channels">Synchronization channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="channels.html#two-channels">Two channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="channels.html#more-senders-or-receivers">More senders or receivers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="channels.html#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="channels.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="buffers.html">Buffers</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="buffers.html#a-one-place-buffer">A one-place buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="buffers.html#a-single-process-buffer">A single process buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="buffers.html#an-infinite-buffer">An infinite buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="buffers.html#a-token-buffer">A token buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="buffers.html#a-priority-buffer">A priority buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="buffers.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="servers.html">Servers with time</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="servers.html#the-clock">The clock</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="servers.html#adding-time">Adding time</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="servers.html#a-deterministic-system">A deterministic system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="servers.html#a-stochastic-system">A stochastic system</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="servers.html#two-servers">Two servers</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="servers.html#serial-system">Serial system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="servers.html#parallel-systems">Parallel systems</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="servers.html#assembly">Assembly</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="servers.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="conveyors.html">Conveyors</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="conveyors.html#timers">Timers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="conveyors.html#a-conveyor">A conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="conveyors.html#a-priority-conveyor">A priority conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="conveyors.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="experiments.html">Simulations and experiments</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="experiments.html#simulating-finite-systems">Simulating finite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="experiments.html#simulating-infinite-systems">Simulating infinite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="experiments.html#simulating-several-scenarios">Simulating several scenarios</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="svg-visualization.html">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-visualization.html#the-svg-file-format">The SVG file format</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-visualization.html#visualization">Visualization</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="svg-example.html">SVG visualization example</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#buffer-visualization">Buffer visualization</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#vertical-coordinates-trickery">Vertical coordinates trickery</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#server-process">Server process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#visualizing-the-server">Visualizing the server</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#copying-svg-elements">Copying SVG elements</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-example.html#moving-svg-elements">Moving SVG elements</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/index.html">Chi Reference Manual</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/globals.html">Global definitions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#enumeration-definitions">Enumeration definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#type-definitions">Type definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#constant-definitions">Constant definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#process-definitions">Process definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#model-definitions">Model definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#function-definitions">Function definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#experiment-definitions">Experiment definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/globals.html#formal-parameters">Formal parameters</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#local-variables">Local variables</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#assignment-statement">Assignment statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html#iterative-statements">Iterative statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#while-loop-statement">While loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#for-loop-statement">For loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#break-statement">Break statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#continue-statement">Continue statement</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#choice-statement">Choice statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html#sub-process-statements">Sub-process statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#run-and-start-statements">Run and start statements</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#finish-statement">Finish statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html#communication-statements">Communication statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#send-statement">Send statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#receive-statement">Receive statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#select-statement">Select statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/statements.html#other-statements">Other statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#delay-statement">Delay statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#write-statement">Write statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#close-statement">Close statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#return-statement">Return statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#exit-statement">Exit statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/statements.html#pass-statement">Pass statement</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/expressions.html">Expressions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#typed-expressions">Typed expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#enumeration-value">Enumeration value</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#boolean-expressions">Boolean expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#integer-expressions">Integer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#real-number-expressions">Real number expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#string-expressions">String expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#list-expressions">List expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#set-expressions">Set expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#dictionary-expressions">Dictionary expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#tuple-expression">Tuple expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#file-handle-expressions">File handle expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#read-expression">Read expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#timer-expressions">Timer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#channel-expressions">Channel expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#distribution-expressions">Distribution expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#process-expressions">Process expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#instance-expressions">Instance expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#matrix-expression">Matrix expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#cast-expressions">Cast expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#function-call-expressions">Function call expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/expressions.html#operator-priorities">Operator priorities</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/stdlib.html">Standard library functions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#integer-functions">Integer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#real-number-functions">Real number functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#string-functions">String functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#list-functions">List functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#set-functions">Set functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#dictionary-functions">Dictionary functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#timer-functions">Timer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#file-functions">File functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/stdlib.html#process-instance-functions">Process instance functions</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/distributions.html">Distributions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/distributions.html#constant-distributions">Constant distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/distributions.html#discrete-distributions">Discrete distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/distributions.html#continuous-distributions">Continuous distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/distributions.html#references">References</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/types.html">Types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/types.html#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#boolean-type">Boolean type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#integer-type">Integer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#real-type">Real type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#string-type">String type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#file-type">File type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#instance-type">Instance type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#timer-type">Timer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#matrix-type">Matrix type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#void-type">Void type</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/types.html#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#list-type">List type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#set-type">Set type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../reference-manual/types.html#dictionary-type">Dictionary type</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#tuple-type">Tuple type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#channel-type">Channel type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#distribution-type">Distribution type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#function-type">Function type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/types.html#process-type">Process type</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/lexicals.html">Lexical syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/lexicals.html#whitespace">Whitespace</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/lexicals.html#comment">Comment</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/lexicals.html#names">Names</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../reference-manual/migration.html">Model migration</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../reference-manual/svg-visualization.html">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/svg-visualization.html#svg-interface">SVG interface</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../reference-manual/svg-visualization.html#visualization-modification-commands">Visualization modification commands</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/index.html">Chi Tool Manual</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html">Software operation</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html#compile-and-simulate">Compile and simulate</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#quick-simulate">Quick simulate</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#compile-only">Compile only</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#simulate-a-compiled-model">Simulate a compiled model</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#terminating-a-simulation">Terminating a simulation</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/command-line.html">Command line options</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#simulator-options">Simulator options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#general-application-options">General application options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#compiler-options">Compiler options</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../release-notes.html">Chi release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../documentation.html">Chi documentation</a> &gt; <a class="breadcrumb" href="index.html">Chi Tutorial</a> &gt; <span class="breadcrumb">Data types</span>
   </div>
   <h2 id="data-types"><a class="anchor" href="#"></a>Data types</h2>
   <div class="paragraph">
    <p>The language is a statically typed language, which means that all variables and values in a model have a single fixed type. All variables must be declared in the program. The declaration of a variable consists of the type, and the name, of the variable. The following fragment shows the declaration of two elementary data types, integer variable <code>i</code> and real variable <code>r</code>:</p>
   </div>
   <div class="listingblock">
    <div class="content">
     <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">...
int i;
real r;
...</code></pre>
    </div>
   </div>
   <div class="paragraph">
    <p>The ellipsis (<code>...</code>) denotes that non-relevant information is left out from the fragment. The syntax for the declaration of variables is similar to the language <em>C</em>. All declared variables are initialized, variables <code>i</code> and <code>r</code> are both initialized to zero.</p>
   </div>
   <div class="paragraph">
    <p>An expression, consisting of operators, e.g. plus (<code>+</code>), times (<code>*</code>), and operands, e.g. <code>i</code> and <code>r</code>, is used to calculate a new value. The new value can be assigned to a variable by using an <em>assignment</em> statement. An example with four variables, two expressions and assignment statements is:</p>
   </div>
   <div class="listingblock">
    <div class="content">
     <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">...
int  i = 2, j;
real r = 1.50, s;

j = 2 * i + 1;
s = r / 2;
...</code></pre>
    </div>
   </div>
   <div class="paragraph">
    <p>The value of variable <code>j</code> becomes <code>5</code>, and the value of <code>s</code> becomes <code>0.75</code>. Statements are described in <a href="statements.html">Statements</a>.</p>
   </div>
   <div class="paragraph">
    <p>Data types are categorized in five different groups: <em>elementary</em> types, <em>tuple</em> types, <em>container</em> types, <em>custom</em> types, and <em>distribution</em> types. Elementary types are types such as Boolean, integer, real or string. Tuple types contain at least one element, where each element can be of different type. In other languages tuple types are called records (Pascal) or structures (C). Variables with a container type (a list, set, or dictionary) contain many elements, where each element is of the same type. Custom types are created by the user to enhance the readability of the model. Distributions types are types used for the generation of distributions from (pseudo-) random numbers. They are covered in <a href="stochastic-behavior.html">Modeling stochastic behavior</a>.</p>
   </div>
   <div class="sect3">
    <h3 id="elementary-types"><a class="anchor" href="#elementary-types"></a>Elementary types</h3>
    <div class="paragraph">
     <p>The elementary data types are Booleans, numbers and strings. The language provides the elementary data types:</p>
    </div>
    <div class="ulist">
     <ul>
      <li><p><code>bool</code> for booleans, with values <code>false</code> and <code>true</code>.</p></li>
      <li><p><code>enum</code> for enumeration types, for example <code>enum FlagColors = {red, white, blue}</code>,</p></li>
      <li><p><code>int</code> for integers, e.g. <code>-7</code>, <code>20</code>, <code>0</code>.</p></li>
      <li><p><code>real</code> for reals, e.g. <code>3.14</code>, <code>7.0e9</code>.</p></li>
      <li><p><code>string</code> for text strings, e.g. <code>"Hello"</code>, <code>"world"</code>.</p></li>
     </ul>
    </div>
    <div class="sect4">
     <h4 id="booleans"><a class="anchor" href="#booleans"></a>Booleans</h4>
     <div class="paragraph">
      <p>A boolean value has two possible values, the truth values. These truth values are <code>false</code> and <code>true</code>. The value <code>false</code> means that a property is not fulfilled. A value <code>true</code> means the presence of a property. Boolean variables are initialized with the value <code>false</code>.</p>
     </div>
     <div class="paragraph">
      <p>In mathematics, various symbols are used for unary and binary boolean operators. These operators are also present in Chi. The most commonly used boolean operators are <code>not</code>, <code>and</code>, and <code>or</code>. The names of the operators, the symbols in mathematics and the symbols in the language are presented in the following table:</p>
     </div>
     <table id="tut-table-boolsymbols" class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 33.3333%;">
       <col style="width: 33.3333%;">
       <col style="width: 33.3334%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top">Operator</th>
        <th class="tableblock halign-left valign-top">Math</th>
        <th class="tableblock halign-left valign-top">Chi</th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">boolean not</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">¬</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>not</code></p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">boolean and</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">∧</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>and</code></p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">boolean or</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">∨</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>or</code></p></td>
       </tr>
      </tbody>
     </table>
     <div class="paragraph">
      <p>Examples of boolean expressions are the following. If <code>z</code> equals <code>true</code>, then the value of <code>(not z)</code> equals <code>false</code>. If <code>s</code> equals <code>false</code>, and <code>t</code> equals <code>true</code>, then the value of the expression <code>(s or t)</code> becomes <code>true</code>.</p>
     </div>
     <div class="paragraph">
      <p>The result of the unary <code>not</code>, the binary <code>and</code> and <code>or</code> operators, for two variables <code>p</code> and <code>q</code> is given in the following table:</p>
     </div>
     <table id="tut-table-truthtable" class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 20%;">
       <col style="width: 20%;">
       <col style="width: 20%;">
       <col style="width: 20%;">
       <col style="width: 20%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top"><code>p</code></th>
        <th class="tableblock halign-left valign-top"><code>q</code></th>
        <th class="tableblock halign-left valign-top"><code>not p</code></th>
        <th class="tableblock halign-left valign-top"><code>p and q</code></th>
        <th class="tableblock halign-left valign-top"><code>p or q</code></th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>false</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>false</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>true</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>false</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>false</code></p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>false</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>true</code></p></td>
        <td class="tableblock halign-left valign-top"></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>false</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>true</code></p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>true</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>false</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>false</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>false</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>true</code></p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>true</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>true</code></p></td>
        <td class="tableblock halign-left valign-top"></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>true</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>true</code></p></td>
       </tr>
      </tbody>
     </table>
     <div class="paragraph">
      <p>If <code>p = true</code> and <code>q = false</code>, we find for <code>p or q</code> the value <code>true</code> (third line in the table).</p>
     </div>
    </div>
    <div class="sect4">
     <h4 id="enumerations"><a class="anchor" href="#enumerations"></a>Enumerations</h4>
     <div class="paragraph">
      <p>Often there are several variants of entities, like types of products, available resources, available machine types, and so on.</p>
     </div>
     <div class="paragraph">
      <p>One way of coding them is give each a unique number, which results in code with a lot of small numbers that are not actually numbers, but refer to one variant.</p>
     </div>
     <div class="paragraph">
      <p>Another way is to give each variant a name (which often already exists), and use those names instead.</p>
     </div>
     <div class="paragraph">
      <p>For example, to model a traffic light:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">enum TrafficColor = {RED, ORANGE, GREEN};

TrafficColor light = RED;</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>The <code>enum TrafficColor</code> line lists the available traffic colors. With this definition, a new type <code>TrafficColor</code> is created, which you can use like any other type. The line <code>TrafficColor light = RED;</code> creates a new variable called <code>light</code> and initializes it to the value <code>RED</code>.</p>
     </div>
    </div>
    <div class="sect4">
     <h4 id="numbers"><a class="anchor" href="#numbers"></a>Numbers</h4>
     <div class="paragraph">
      <p>In the language, two types of numbers are available: integer numbers and real numbers. Integer numbers are whole numbers, denoted by type <code>int</code> e.g. <code>3</code>, <code>-10</code>, <code>0</code>. Real numbers are used to present numbers with a fraction, denoted by type <code>real</code>. E.g. <code>3.14</code>, <code>2.7e6</code> (the scientific notation for 2.7 million). Note that real numbers <em>must</em> either have a fraction or use the scientific notation, to let the computer know you mean a real number (instead of an integer number). Integer variables are initialized with <code>0</code>. Real variables are initialized with <code>0.0</code>.</p>
     </div>
     <div class="paragraph">
      <p>For numbers, the normal arithmetic operators are defined. Expressions can be constructed with these operators. The arithmetic operators for numbers are listed in the following table:</p>
     </div>
     <table id="tut-table-aritoper" class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 33.3333%;">
       <col style="width: 33.3333%;">
       <col style="width: 33.3334%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top">Operator name</th>
        <th class="tableblock halign-left valign-top">Notation</th>
        <th class="tableblock halign-left valign-top">Comment</th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">unary plus</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>+ x</code></p></td>
        <td class="tableblock halign-left valign-top"></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">unary minus</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>- x</code></p></td>
        <td class="tableblock halign-left valign-top"></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">raising to the power</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x ^ y</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">Always a <code>real</code> result.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">multiplication</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x * y</code></p></td>
        <td class="tableblock halign-left valign-top"></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">real division</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x / y</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">Always a <code>real</code> result.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">division</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x div y</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">For <code>int</code> only.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">modulo</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x mod y</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">For <code>int</code> only.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">addition</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x + y</code></p></td>
        <td class="tableblock halign-left valign-top"></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">subtraction</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x - y</code></p></td>
        <td class="tableblock halign-left valign-top"></td>
       </tr>
      </tbody>
     </table>
     <div class="paragraph">
      <p>The priority of the operators is given from high to low. The unary operators have the strongest binding, and the <code>+</code> and <code>-</code> the weakest binding. So, <code>-3^2</code> is read as <code>(-3)^2</code> and not <code>-(3^2)</code>, because the priority rules say that the unary operator binds stronger than the raising to the power operator. Binding in expressions can be changed by the use of parentheses.</p>
     </div>
     <div class="paragraph">
      <p>The integer division, denoted by <code>div</code>, gives the biggest integral number smaller or equal to <code>x / y</code>. The integer remainder, denoted by <code>mod</code>, gives the remainder after division <code>x - y * (x div y)</code>. So, <code>7 div 3</code> gives <code>2</code> and <code>-7 div 3</code> gives <code>-3</code>, <code>7 mod 3</code> gives <code>1</code> and <code>-7 mod 3</code> gives <code>2</code>.</p>
     </div>
     <div class="paragraph">
      <p>The rule for the result of an operation is as follows. The real division and raising to the power operations always produce a value of type <code>real</code>. Otherwise, if both operands (thus <code>x</code> and <code>y</code>) are of type <code>int</code>, the result of the operation is of type <code>int</code>. If one of the operands is of type <code>real</code>, the result of the operation is of type <code>real</code>.</p>
     </div>
     <div class="paragraph">
      <p>Conversion functions exist to convert a real into an integer. The function <code>ceil</code> converts a real to the smallest integer value not less than the real, the function <code>floor</code> gives the biggest integer value smaller than or equal to the real, and the function <code>round</code> rounds the real to the nearest integer value (or up, if it ends on <code>.5</code>).</p>
     </div>
     <div class="paragraph">
      <p>Between two numbers a relational operation can be defined. If for example variable <code>x</code> is smaller than variable <code>y</code>, the expression <code>x &lt; y</code> equals <code>true</code>. The relational operators, with well-known semantics, are listed in the following table:</p>
     </div>
     <table id="tut-table-reloper" class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 50%;">
       <col style="width: 50%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top">Name</th>
        <th class="tableblock halign-left valign-top">Operator</th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">less than</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x &lt; y</code></p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">at most</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x &lt;= y</code></p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">equals</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x == y</code></p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">differs from</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x != y</code></p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">at least</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x &gt;= y</code></p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">greater than</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x &gt; y</code></p></td>
       </tr>
      </tbody>
     </table>
    </div>
    <div class="sect4">
     <h4 id="strings"><a class="anchor" href="#strings"></a>Strings</h4>
     <div class="paragraph">
      <p>Variables of type string contains a sequence of characters. A string is enclosed by double quotes. An example is <code>"Manufacturing line"</code>. Strings can be composed from different strings. The concatenation operator (<code>+</code>) adds one string to another, for example <code>"One" + " " + "string"</code> gives <code>"One string"</code>. Moreover the relational operators (<code>&lt;</code>, <code>&lt;=</code>, <code>==</code>, <code>!=</code> <code>&gt;=</code>, and <code>&gt;</code>) can be used to compare strings alphabetically, e.g. <code>"a" &lt; "aa" &lt; "ab" &lt; "b"</code>. String variables are initialized with the empty string <code>""</code>.</p>
     </div>
    </div>
   </div>
   <div class="sect3">
    <h3 id="tuple-types"><a class="anchor" href="#tuple-types"></a>Tuple types</h3>
    <div class="paragraph">
     <p>Tuple types are used for keeping several (related) kinds of data together in one variable, e.g. the name and the age of a person. A tuple variable consists of a number of fields inside the tuple, where the types of these fields may be different. The number of fields is fixed. One operator, the projection operator denoted by a dot (<code>.</code>), is defined for tuples. It selects a field in the tuple for reading or assigning.</p>
    </div>
    <div class="sect4">
     <h4 id="notation"><a class="anchor" href="#notation"></a>Notation</h4>
     <div class="paragraph">
      <p>A type <code>person</code> is a tuple with two fields, a 'name' field of type <code>string</code>, and an 'age' field of type <code>int</code>, is denoted by:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">type person = tuple(string name; int age)</code></pre>
      </div>
     </div>
    </div>
    <div class="sect4">
     <h4 id="operator"><a class="anchor" href="#operator"></a>Operator</h4>
     <div class="paragraph">
      <p>A projection operator fetches a field from a tuple. We define two persons:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">person eva  = ("eva" , 29),
       adam = ("adam", 27);</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>And we can speak of <code>eva.name</code> and <code>adam.age</code>, denoting the name of <code>eva</code> (<code>"eva"</code>) and the age of <code>adam</code> (<code>27</code>). We can assign a field in a tuple to another variable:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">ae = eva.age;
eva.age = eva.age + 1;</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>This means that the age of <code>eva</code> is assigned tot variable <code>ae</code>, and the new age of <code>eva</code> becomes <code>eva.age + 1</code>.</p>
     </div>
     <div class="paragraph">
      <p>By using a multi assignment statement all values of a tuple can be copied into separate variables:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">string name;
int age;

name, age = eva</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>This assignment copies the name of <code>eva</code> into variable <code>name</code> of type <code>string</code> and her age into <code>age</code> of type <code>int</code>.</p>
     </div>
    </div>
   </div>
   <div class="sect3">
    <h3 id="container-types"><a class="anchor" href="#container-types"></a>Container types</h3>
    <div class="paragraph">
     <p>Lists, sets and dictionaries are container types. A variable of this type contains zero or more identical elements. Elements can be added or removed in variables of these types. Variables of a container type are initialized with zero elements.</p>
    </div>
    <div class="paragraph">
     <p>Sets are unordered collections of elements. Each element value either exists in a set, or it does not exist in a set. Each element value is unique, duplicate elements are silently discarded. A list is an ordered collection of elements, that is, there is a first and a last element (in a non-empty list). A list also allows duplicate element values. Dictionaries are unordered and have no duplicate value, just like sets, but you can associate a value (of a different type) with each element value.</p>
    </div>
    <div class="paragraph">
     <p>Lists are denoted by a pair of (square) brackets. For example, <code>[7, 8, 3]</code> is a list with three integer elements. Since a list is ordered, <code>[8, 7, 3]</code> is a different list. With empty lists, the computer has to know the type of the elements, e.g. <code>&lt;int&gt;[]</code> is an empty list with integer elements. The prefix <code>&lt;int&gt;</code> is required in this case.</p>
    </div>
    <div class="paragraph">
     <p>Sets are denoted by a pair of (curly) braces, e.g. <code>{7, 8, 3}</code> is a set with three integer elements. As with lists, for an empty set a prefix is required, for example <code>&lt;string&gt;{}</code> is an empty set with strings. A set is an unordered collection of elements. The set <code>{7, 8, 3}</code> is a set with three integer numbers. Since order of the elements does not matter, the same set can also be written as <code>{8, 3, 7}</code> (or in one of the four other orders). In addition, each element in a set is unique, the set <code>{8, 7, 8, 3}</code> is equal to the set <code>{7, 8, 3}</code>. For readability, elements in a set are normally written in increasing order, for example <code>{3, 7, 8}</code>.</p>
    </div>
    <div class="paragraph">
     <p>Dictionaries are denoted by a pair of (curly) braces, whereby an element value consists of two parts, a 'key' and a 'value' part. The two parts separated by a colon (<code>:</code>). For example <code>{"jim" : 32, "john" : 34}</code> is a dictionary with two elements. The first element has <code>"jim"</code> as key part and <code>32</code> as value part, the second element has <code>"john"</code> as key part and <code>34</code> as value part. The key parts of the elements work like a set, they are unordered and duplicates are silently discarded. A value part is associated with its key part. In this example, the key part is the name of a person, while the value part keeps the age of that person. Empty dictionaries are written with a type prefix just like lists and sets, e.g. <code>&lt;string:int&gt;{}</code>.</p>
    </div>
    <div class="paragraph">
     <p>Container types have some built-in functions in common (Functions are described in <a href="functions.html">Functions</a>):</p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>The function <code>size</code> gives the number of elements in a variable, for example <code>size([7, 8, 3])</code> yields 3; <code>size({7, 8})</code> results in 2; <code>size({"jim":32})</code> gives 1 (an element consists of two parts).</p></li>
     </ul>
    </div>
    <div class="ulist">
     <ul>
      <li><p>The function <code>empty</code> yields <code>true</code> if there are no elements in variable. E.g. <code>empty(&lt;string&gt;{})</code> with an empty set of type <code>string</code> is true. (Here the type <code>string</code> is needed to determine the type of the elements of the empty set.)</p></li>
     </ul>
    </div>
    <div class="ulist">
     <ul>
      <li><p>The function <code>pop</code> extracts a value from the provided collection and returns a tuple with that value, and the collection minus the value.</p>
       <div class="paragraph">
        <p>For lists, the first element of the list becomes the first field of the tuple. The second field of the tuple becomes the list minus the first list element. For example:</p>
       </div>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">pop([7, 8, 3]) -&gt; (7, [8, 3])</code></pre>
        </div>
       </div>
       <div class="paragraph">
        <p>The <code>-&gt;</code> above denotes 'yields'. The value of the list is split into a 'head' (the first element) and a 'tail' (the remaining elements).</p>
       </div>
       <div class="paragraph">
        <p>For sets, the first field of the tuple becomes the value of an arbitrary element from the set. The second field of the tuple becomes the original set minus the arbitrary element. For example, a <code>pop</code> on the set <code>{8, 7, 3}</code> has three possible answers:</p>
       </div>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">pop({8, 7, 3}) -&gt; (7, {3, 8}) or
pop({8, 7, 3}) -&gt; (3, {7, 8}) or
pop({8, 7, 3}) -&gt; (8, {3, 7})</code></pre>
        </div>
       </div>
       <div class="paragraph">
        <p>Performing a <code>pop</code> on a dictionary follows the same pattern as above, except 'a value from the collection' are actually a key item and a value item. In this case, the <code>pop</code> function gives a three-tuple as result. The first field of the tuple becomes the key of the extracted element, the second field of the tuple becomes the value of the element, and the third field of the tuple contains the dictionary except for the extracted element. Examples:</p>
       </div>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">pop({"a" : 32, "b" : 34}) -&gt; ("a", 32, {"b" : 34}) or
pop({"a" : 32, "b" : 34}) -&gt; ("b", 34, {"a" : 32})</code></pre>
        </div>
       </div></li>
     </ul>
    </div>
    <div class="sect4">
     <h4 id="lists"><a class="anchor" href="#lists"></a>Lists</h4>
     <div class="paragraph">
      <p>A list is an ordered collection of elements of the same type. They are useful to model anything where duplicate values may occur or where order of the values is significant. Examples are waiting customers in a shop, process steps in a recipe, or products stored in a warehouse. Various operations are defined for lists.</p>
     </div>
     <div class="paragraph">
      <p>An element can be fetched by <em>indexing</em>. This indexing operation does not change the content of the variable. The first element of a list has index <code>0</code>. The last element of a list has index <code>size(xs) - 1</code>. A negative index, say <code>m</code>, starts from the back of the list, or equivalently, at offset <code>size(xs) + m</code> from the front. You cannot index non-existing elements. Some examples, with <code>xs = [7, 8, 3, 5, 9]</code> are:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">xs[0]  -&gt; 7
xs[3]  -&gt; 5
xs[5]  -&gt; ERROR (there is no element at position 5)
xs[-1] -&gt; xs[5 - 1] -&gt; xs[4] -&gt; 9
xs[-2] -&gt; xs[5 - 2] -&gt; xs[3] -&gt; 5</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>In the figure below, the list with indices is visualized. A common name for the first element of a list (i.e., <code>x[0]</code>) is the <em>head</em> of a list. Similarly, the last element of a list (<code>xs[-1]</code>) is also known as <em>head right</em>.</p>
     </div>
     <div id="tut-figure-list-with-indices" class="imageblock">
      <div class="content"><img src="pictures/list_with_indices.png" alt="list with indices">
      </div>
     </div>
     <div class="paragraph">
      <p>A part of a list can be fetched by <em>slicing</em>. The slicing operation does not change the content of the list, it copies a contiguous sequence of a list. The result of a slice operation is again a list, even if the slice contains just one element.</p>
     </div>
     <div class="paragraph">
      <p>Slicing is denoted by <code>xs[i:j]</code>. The slice of <code>xs[i:j]</code> is defined as the sequence of elements with index <code>k</code> such that <code>i &lt;= k &lt; j</code>. Note the upper bound <code>j</code> is noninclusive. If <code>i</code> is omitted use <code>0</code>. If <code>j</code> is omitted use <code>size(xs)</code>. If <code>i</code> is greater than or equal to <code>j</code>, the slice is empty. If <code>i</code> or <code>j</code> is negative, the index is relative to the end of the list: <code>size(xs) + i</code> or <code>size(xs) + j</code> is substituted. Some examples with <code>xs = [7, 8, 3, 5, 9]</code>:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">xs[1:3] -&gt; [8, 3]
xs[:2]  -&gt; [7, 8]
xs[1:]  -&gt; [8, 3, 5, 9]
xs[:-1] -&gt; [7, 8, 3, 5]
xs[:-3] -&gt; [7, 8]</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>The list of all but the first elements (<code>xs[1:]</code>) is often called <em>tail</em> and <code>xs[:-1]</code> is also known as <em>tail right</em>. Below, the slicing operator is visualized:</p>
     </div>
     <div id="tut-figure-list-with-slices" class="imageblock">
      <div class="content"><img src="pictures/list_with_slices.png" alt="list with slices">
      </div>
     </div>
     <div class="paragraph">
      <p>Two lists can be 'glued' together into a new list. The glue-ing or concatenation of a list with elements <code>7</code>, <code>8</code>, <code>3</code> and a list with elements <code>5</code>, and <code>9</code> is denoted by:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">[7, 8, 3] + [5, 9] -&gt; [7, 8, 3, 5, 9]</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>An element can be added to a list at the rear or at the front. The action is performed by transforming the element into a list and then concatenate these two lists. In the next example the value <code>5</code> is added to the rear, respectively the front, of a list:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">[7, 8, 3] + [5] -&gt; [7, 8, 3, 5]
[5] + [7, 8, 3] -&gt; [5, 7, 8, 3]</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>Elements also can be removed from a list. The <code>del</code> function removes by position, e.g. <code>del(xs, 2)</code> returns the list <code>xs</code> without its third element (since positions start at index 0). Removing a value by value can be performed by the subtraction operator <code>-</code>. For instance, consider the following subtractions:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">[1, 4, 2, 4, 5] - [2] -&gt; [1, 4, 4, 5]
[1, 4, 2, 4, 5] - [4] -&gt; [1, 2, 4, 5]
[1, 4, 2, 4, 5] - [8] -&gt; [1, 4, 2, 4, 5]</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>Every element in the list at the right is searched in the list at the left, and if found, the <em>first</em> occurrence is removed. In the first example, element <code>2</code> is removed. In the second example, only the first value <code>4</code> is removed and the second value (at position 3) is kept. In the third example, nothing is removed, since value <code>8</code> is not in the list at the left.</p>
     </div>
     <div class="paragraph">
      <p>When the list at the right is longer than one element, the operation is repeated. For example, consider <code>xs - ys</code>, whereby <code>xs = [1, 2, 3, 4, 5]</code> and <code>ys = [6, 4, 2, 3]</code>. The result is computed as follows:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">    [1, 2, 3, 4, 5] - [6, 4, 2, 3]
-&gt; ([1, 2, 3, 4, 5] - [6]) - [4, 2, 3]
-&gt;  [1, 2, 3, 4, 5] - [4, 2, 3]
-&gt; ([1, 2, 3, 4, 5] - [4]) - [2, 3]
-&gt;  [1, 2, 3,    5] - [2, 3]
-&gt; ([1, 2, 3,    5] - [2]) - [3]
-&gt;  [1,    3,    5] - [3]
-&gt; [1,5]</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>Lists have two relational operators, the equal operator and the not-equal operator. The equal operator (<code>==</code>) compares two lists. If the lists have the same number of elements and all the elements are pair-wise the same, the result of the operation is <code>true</code>, otherwise <code>false</code>. The not-equal operator (<code>!=</code>) does the same check, but with an opposite result. Some examples, with <code>xs = [7, 8, 3]</code>:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">xs == [7, 8, 3] -&gt; true
xs == [7, 7, 7] -&gt; false</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>The membership operator (<code>in</code>) checks if an element is in a list. Some examples, with <code>xs = [7, 8, 3]</code>:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">6 in xs -&gt; false
7 in xs -&gt; true
8 in xs -&gt; true</code></pre>
      </div>
     </div>
    </div>
    <div class="sect4">
     <h4 id="initialization"><a class="anchor" href="#initialization"></a>Initialization</h4>
     <div class="paragraph">
      <p>A list variable is initialized with a list with zero elements, for example in:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">list int xs;</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>The initial value of <code>xs</code> equals <code>&lt;int&gt;[]</code>.</p>
     </div>
     <div class="paragraph">
      <p>A list can be initialized with a number, denoting the number of elements in the list:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">list(2) int ys</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>This declaration creates a list with <code>2</code> elements, whereby each element of type <code>int</code> is initialized. The initial value of <code>ys</code> equals <code>[0, 0]</code>. Another example with a list of lists:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">list(4) list(2) int zm</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>This declaration initializes variable <code>zm</code> with the value <code>[ [0, 0], [0, 0], [0, 0], [0, 0] ]</code>.</p>
     </div>
    </div>
    <div class="sect4">
     <h4 id="sets"><a class="anchor" href="#sets"></a>Sets</h4>
     <div class="paragraph">
      <p>Set operators for union, intersection and difference are present. The table below gives the name, the mathematical notation and the notation in the Chi language:</p>
     </div>
     <table id="tut-table-set-operations" class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 33.3333%;">
       <col style="width: 33.3333%;">
       <col style="width: 33.3334%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top">Operator</th>
        <th class="tableblock halign-left valign-top">Math</th>
        <th class="tableblock halign-left valign-top">Chi</th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">set union</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">∪</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>+</code></p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">set intersection</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">∩</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>*</code></p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock">set difference</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">∖</p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>-</code></p></td>
       </tr>
      </tbody>
     </table>
     <div class="paragraph">
      <p>The union of two sets merges the values of both sets into one, that is, the result is the collection of values that appear in at least one of the arguments of the union operation. Some examples:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">{3, 7, 8} + {5, 9} -&gt; {3, 5, 7, 8, 9}</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>All permutations with the elements <code>3</code>, <code>5</code>, <code>7</code>, <code>8</code> and <code>9</code> are correct (sets have no order, all permutations are equivalent). To keep sets readable the elements are sorted in increasing order in this tutorial.</p>
     </div>
     <div class="paragraph">
      <p>Values that occur in both arguments, appear only one time in the result (sets silently discard duplicate elements). For example:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">{3, 7, 8} + {7, 9} -&gt; {3, 7, 8, 9}</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>The intersection of two sets gives a set with the common elements, that is, all values that occur in <em>both</em> arguments. Some examples:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">{3, 7, 8} * {5, 9} -&gt; &lt;int&gt;{}   # no common element
{3, 7, 8} * {7, 9} -&gt; {7}       # only 7 in common</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>Set difference works much like subtraction on lists, except elements occur at most one time (and have no order). The operation computes 'remaining elements'. The result is a new set containing all values from the first set which are not in the second set. Some examples:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">{3, 7, 8} - {5, 9} -&gt; {3, 7, 8}
{3, 7, 8} - {7, 9} -&gt; {3, 9}</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>The membership operator <code>in</code> works on sets too:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">3 in {3, 7, 8} -&gt; true
9 in {3, 7, 8} -&gt; false</code></pre>
      </div>
     </div>
    </div>
    <div class="sect4">
     <h4 id="dictionaries"><a class="anchor" href="#dictionaries"></a>Dictionaries</h4>
     <div class="paragraph">
      <p>Elements of dictionaries are stored according to a key, while lists elements are ordered by a (relative) position, and set elements are not ordered at all. A dictionary can grow and shrink by adding or removing elements respectively, like a list or a set. An element of a dictionary is accessed by the key of the element.</p>
     </div>
     <div class="paragraph">
      <p>The dictionary variable <code>d</code> of type <code>dict(string : int)</code> is given by:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">dict (string : int) d =
    {"jim"  : 32,
     "john" : 34,
     "adam" : 25}</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>Retrieving values of the dictionary by using the key:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">d["john"] -&gt; 34
d["adam"] -&gt; 25</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>Using a non-existing key to retrieve a value results in a error message.</p>
     </div>
     <div class="paragraph">
      <p>A new value can be assigned to the variable by selecting the key of the element:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">d["john"] = 35</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>This assignment changes the value of the <code>"john"</code> item to <code>35</code>. The assignment can also be used to add new items:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">d["lisa"] = 19</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>Membership testing of keys in dictionaries can be done with the <code>in</code> operator:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">"jim" in d -&gt; true
"peter" in d -&gt; false</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>Merging two dictionaries is done by adding them together. The value of the second dictionary is used when a key exists in both dictionaries:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">{1 : 1, 2 : 2} + {1 : 5, 3 : 3} -&gt; {1 : 5, 2 : 2, 3 : 3}</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>The left dictionary is copied, and updated with each item of the right dictionary.</p>
     </div>
     <div class="paragraph">
      <p>Removing elements can be done with subtraction, based on key values. Lists and sets can also be used to denote which keys should be removed. A few examples for <code>p</code> is <code>{1 : 1, 2 : 2}</code>:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">p - {1 : 3, 5 : 5} -&gt; {2 : 2}
p - {1, 7} -&gt; {2 : 2}
p - [2, 8] -&gt; {1 : 1}</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>Subtracting keys that do not exist in the left dictionary is allowed and has no effect.</p>
     </div>
    </div>
   </div>
   <div class="sect3">
    <h3 id="custom-types"><a class="anchor" href="#custom-types"></a>Custom types</h3>
    <div class="paragraph">
     <p>To structure data the language allows the creation of new types. The definition can only be done at global level, that is, outside any <code>proc</code>, <code>func</code>, <code>model</code>, or <code>xper</code> definition.</p>
    </div>
    <div class="paragraph">
     <p>Types can be used as alias for elementary data types to increase readability, for example a variable of type <code>item</code>:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">type item = real;</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Variables of type <code>item</code> are, e.g.:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">item box, product;

box = 4.0; product = 120.5;</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>This definition creates the possibility to speak about an item.</p>
    </div>
    <div class="paragraph">
     <p>Types also can be used to make combinations of other data types, e.g. a recipe:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">type step   = tuple(string name; real process_time),
     recipe = tuple(int id; list step steps);</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>A type <code>step</code> is defined by a <code>tuple</code> with two fields, a field with <code>name</code> of type <code>string</code>, denoting the name of the step, and a field with <code>process_time</code> of type <code>real</code>, denoting the duration of the (processing) step. The <code>step</code> definition is used in the type <code>recipe</code>. Type <code>recipe</code> is defined by a <code>tuple</code> with two fields, an <code>id</code> of type <code>int</code>, denoting the identification number, and a field <code>steps</code> of type <code>list step</code>, denoting a list of single steps. Variables of type recipe are, e.g.:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">recipe plate, bread;
plate = (34, [("s", 10.8), ("w", 13.7), ("s", 25.6)]);
bread = (90, [("flour", 16.3), ("yeast", 6.9)]);</code></pre>
     </div>
    </div>
   </div>
   <div class="sect3">
    <h3 id="exercises"><a class="anchor" href="#exercises"></a>Exercises</h3>
    <div class="olist arabic">
     <ol class="arabic">
      <li><p>Exercises for integer numbers. What is the result of the following expressions:</p>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">-5 ^ 3
-5 * 3
5 mod 3</code></pre>
        </div>
       </div></li>
      <li><p>Exercises for tuples. Given are tuple type <code>box</code> and variable <code>x</code> of type <code>box</code>:</p>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">type box = tuple(string name; real weight);
box x = ("White", 12.5);</code></pre>
        </div>
       </div>
       <div class="paragraph">
        <p>What is the result of the following expressions:</p>
       </div>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">x.name
x.real
x</code></pre>
        </div>
       </div></li>
      <li><p>Exercises for lists. Given is the list <code>xs = [0,1,2,3,4,5,6]</code>. Determine the outcome of:</p>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">xs[0]
xs[1:]
size(xs)
xs + [3]
[4,5] + xs
xs - [2,2,3]
xs - xs[2:]
xs[0] + (xs[1:])[0]</code></pre>
        </div>
       </div></li>
     </ol>
    </div>
   </div>
  </div>
  <script src="../assets/highlight.min.js"></script>
  <script src="../assets/languages/asciidoc.min.js"></script>
  <script src="../assets/languages/bash.min.js"></script>
  <script src="../assets/languages/bnf.min.js"></script>
  <script src="../assets/languages/c.min.js"></script>
  <script src="../assets/languages/chi.min.js"></script>
  <script src="../assets/languages/cif.min.js"></script>
  <script src="../assets/languages/console.min.js"></script>
  <script src="../assets/languages/css.min.js"></script>
  <script src="../assets/languages/dsm.min.js"></script>
  <script src="../assets/languages/java.min.js"></script>
  <script src="../assets/languages/javascript.min.js"></script>
  <script src="../assets/languages/markdown.min.js"></script>
  <script src="../assets/languages/mcrl2.min.js"></script>
  <script src="../assets/languages/none.min.js"></script>
  <script src="../assets/languages/properties.min.js"></script>
  <script src="../assets/languages/raildiagram.min.js"></script>
  <script src="../assets/languages/setext.min.js"></script>
  <script src="../assets/languages/shell.min.js"></script>
  <script src="../assets/languages/tooldef.min.js"></script>
  <script src="../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>Chi documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v4.0</span><br> <a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>